/**
 * @license
 * declarative - Mapper for custom user interface markup - version 1.3.7
 * Copyright 2012, Alex Lawrence
 * Licensed under the MIT license.
 * http://www.opensource.org/licenses/MIT
 */
(function(e,t){typeof exports=="object"?module.exports=t():typeof define=="function"&&define.amd?define(t):e.declarative=t()})(this,function(){function define(e,t,n){define[e]=require(n?t:[],n||t)}function require(e,t,n,r){n=[];for(r in e)n[r]=define[e[r]];return t.apply(0,n)}define("settings",function(){return{mappingTimeoutMs:1e3,mappingWaitTimeMs:20}}),define("errors",function(){var e={};return e.parseOptions="declarative: Error parsing options",e.verifyDomElement="declarative: Invalid DOM element given",e.getSingleMapping="declarative: Mapping id not existing",e.validateMapping="declarative: Invalid mapping options",e.validateMappingId="declarative: Invalid mapping id",e.validateMappingTypes="declarative: Missing mapping types",e.validateMappingTypesFormat="declarative: Invalid mapping types",e.validateMappingCallback="declarative: Invalid mapping callback",e.validateMappingMode="declarative: Invalid mappingMode",e}),define("mappingModes",function(){var e={attribute:"attribute",element:"element"};return e}),define("common/array",function(){var e={};return e.ensureArray=function(t){return e.isArray(t)?t:[t]},e.isArray=function(e){return Object.prototype.toString.call(e)==="[object Array]"},e.indexOf=function(e,t){for(var n=0,r=e.length;n<r;n++)if(e[n]==t)return n;return-1},e}),define("common/async",function(){var e=function(e){var t,n=function(){t=(new Date).getTime(),e(r,i)},r=function(){return(new Date).getTime()-t},i=function(e){setTimeout(n,e)};n()};return e}),define("common/Deferred",function(){var e=function(){if(!(this instanceof e))return new e;var r=null,i="resolved",s="rejected",o,u,a=[],f=[];this.then=function(t,l){var c=new e;return l=l||function(){},t=t||function(){},t=n(this,t,c),r==i&&t.apply(this,o),r==s&&l.apply(this,u),a.push(t),f.push(l),c},this.resolve=function(){r||(o=arguments,t(this,a,o),r=i)},this.reject=function(){r||(u=arguments,t(this,f,u),r=s)}},t=function(e,t,n){for(var r=0,i=t.length;r<i;r++)t[r].apply(e,n)},n=function(e,t,n){return function(){try{n.resolve(t.apply(e,arguments))}catch(r){n.reject(r)}}};return e}),define("common/hyphenate",function(){var e=new RegExp(/([A-Z])/g),t=function(t){return t.replace(e,function(e,t){return"-"+t.toLowerCase()})};return t}),define("common/parseOptions",["errors"],function(errors){var parseOptions=function(input){try{var output;return eval("output = {"+input+"}")}catch(error){throw new Error(errors.parseOptions)}};return parseOptions}),define("dom/generateCssSelectors",["mappingModes"],function(e){var t=function(t){var s=n(t[e.attribute]),o=r(t[e.element]);return i(s,o)},n=function(e){var t=e.join("],[");return t&&(t="["+t+"]"),t},r=function(e){return e.join(",")},i=function(e,t){return e+(e&&t?",":"")+t};return t}),define("dom/getRelevantElements",["dom/generateCssSelectors","mappingModes"],function(e,t){var n=function(e,t){return e.querySelectorAll?r(e,t):e.all?e.all:e.getElementsByTagName("*")},r=function(n,r){var i={};i[t.attribute]=[],i[t.element]=[];for(var s=0,o=r.length;s<o;s++){var u=r[s],a=u.mappingMode;i[a]=i[a].concat(u.convertedTypes)}var f=e(i);return n.querySelectorAll(f)};return n}),define("dom/getSpecifiedAttributes",["errors","dom/isDomElement"],function(e,t){var n=function(e){r(e);var t=e.attributes,n,i={};for(var s=0,o=t.length;s<o;s++)n=t[s],n.specified&&(i[n.nodeName]=n.nodeValue);return i},r=function(n){if(!t(n))throw new Error(e.verifyDomElement)};return n}),define("dom/isDomElement",function(){var e=function(e){return e&&(e.nodeType===t||e.nodeType===n)},t=1,n=9;return e}),define("mapping/validateMapping",["mappingModes","errors"],function(e,t){var n=function(n){n||r(t.validateMapping),n.id||r(t.validateMappingId),n.types||r(t.validateMappingTypes),n.types&&!n.types.push&&r(t.validateMappingTypesFormat),(!n.callback||typeof n.callback!="function")&&r(t.validateMappingCallback),n.mappingMode&&n.mappingMode!==e.attribute&&n.mappingMode!==e.element&&r(t.validateMappingMode)},r=function(e){throw new Error(e)};return n}),define("mapping/completeMapping",["mappingModes"],function(e){var t=function(t){t.prefix=t.prefix||"",t.mappingMode=t.mappingMode||e.attribute,t.distinct=t.distinct!==undefined?t.distinct:!0};return t}),define("mapping/optimizeMapping",["common/hyphenate"],function(e){var t=function(t){t.prefix=t.prefix.toLowerCase(),t.convertedTypes=[];for(var n=0,r=t.types.length;n<r;n++){var i=e(t.types[n]);t.convertedTypes.push(t.prefix+i)}};return t}),define("mapping/mappings",["common/array","errors","mapping/validateMapping","mapping/completeMapping","mapping/optimizeMapping"],function(e,t,n,r,i){var s={};s.clear=function(){a={}},s.add=function(t){t=e.ensureArray(t);for(var s=0,o=t.length;s<o;s++){var u=t[s];n(u),r(u),i(u),a[u.id]=u}},s.getAll=function(){var e=[];for(var t in a)a.hasOwnProperty(t)&&e.push(a[t]);return e},s.get=function(t){if(!e.isArray(t))return o(t);var n=[];for(var r=0,i=t.length;r<i;r++)n.push(o(t[r]));return n};var o=function(e){return a[e]||u()},u=function(){throw new Error(t.getSingleMapping)},a={};return s}),define("mapping/apply",["mappingModes","errors","settings","common/array","common/parseOptions","common/async","common/Deferred","dom/isDomElement","dom/getSpecifiedAttributes","dom/getRelevantElements","mapping/mappings"],function(e,t,n,r,i,s,o,u,a,f,l){var c=function(e){var t=l.get(e);return t=r.ensureArray(t),h(t)},h=function(e){return{to:function(t){return p(e,t)}}},p=function(t,r){d(r);var i=f(r,t),u,a,l=i.length,c=r!=document?r:i[--l],h=0,p=t.length,y=0,b=0,w=new o;return s(function(r,s){while(c){a=c.attributes;for(h=0;h<p;h++){u=t[h];for(y=0,b=u.convertedTypes.length;y<b;y++){if(v(u,c,u.convertedTypes[y]))continue;u.mappingMode===e.attribute&&m(c,u,y),u.mappingMode===e.element&&g(c,u,y)}}c=l&&i[--l];if(r()>n.mappingTimeoutMs){s(n.mappingWaitTimeMs);return}}w.resolve()}),w},d=function(e){if(!u(e))throw new Error(t.verifyDomElement)},v=function(e,t,n){var i=t.getAttribute(w);return e.distinct&&i>0&&r.indexOf(b[i],n)>-1},m=function(e,t,n){var r=e.getAttributeNode(t.convertedTypes[n]);if(r&&r.specified){var s=i(r.nodeValue);t.callback(e,t.types[n],s),y(e,t,t.convertedTypes[n])}},g=function(e,t,n){if(e.nodeName.toLowerCase()==t.convertedTypes[n]){var r=a(e);t.callback(e,t.types[n],r),y(e,t,t.convertedTypes[n])}},y=function(e,t,n){if(t.distinct){var r=e.getAttribute(w);r||(r=E++,e.setAttribute(w,r)),b[r]=b[r]||[],b[r].push(n)}},b={},w="data-declarative-id",E=1;return c}),define("mapping/applyAllMappings",["mapping/mappings","mapping/apply"],function(e,t){return function(){var n=[],r=e.getAll();for(var i=0,s=r.length;i<s;i++)n.push(r[i].id);return t(n)}});var declarative={};return require(["mappingModes","mapping/mappings","mapping/apply","mapping/applyAllMappings","settings"],function(e,t,n,r,i){declarative.mappingModes=e,declarative.mappings=t,declarative.apply=n,declarative.applyAllMappings=r,declarative.settings=i}),declarative.version="1.3.7",declarative});